## lomiri-system-settings-security-privacy 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(lomiri-system-settings-security-privacy VERSION 1.0.2 LANGUAGES C CXX)

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(FindPkgConfig)
include(GNUInstallDirs)
include(FindIntl)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(NOT Intl_FOUND)
    message(FATAL_ERROR "libintl library not found")
endif()

find_package(Qt5
    COMPONENTS
        Core
        Gui
        DBus
        Network
        Quick
        Qml
    REQUIRED
)

pkg_check_modules(LomiriSystemSettings
    REQUIRED IMPORTED_TARGET
    LomiriSystemSettings
)
pkg_get_variable(PLUGIN_MANIFEST_DIR LomiriSystemSettings plugin_manifest_dir)
pkg_get_variable(PLUGIN_PRIVATE_MODULE_DIR LomiriSystemSettings plugin_private_module_dir)
pkg_get_variable(PLUGIN_QML_DIR LomiriSystemSettings plugin_qml_dir)

pkg_check_modules(POLKIT_AGENT REQUIRED polkit-agent-1)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(TRUST_STORE REQUIRED trust-store)
pkg_check_modules(LIBSYSTEMD REQUIRED libsystemd)

add_subdirectory(plugins/security-privacy)

add_subdirectory(po)

option(ENABLE_TESTS "Build tests" ON)
if(ENABLE_TESTS)
    enable_testing()
    find_package(Qt5 COMPONENTS Test REQUIRED)
    pkg_check_modules(QtDBusMock
        REQUIRED IMPORTED_TARGET
        libqtdbusmock-1
    )
    pkg_check_modules(QtDBusTest
        REQUIRED IMPORTED_TARGET
        libqtdbustest-1
    )
    pkg_check_modules(GLib
        REQUIRED IMPORTED_TARGET
        glib-2.0
    )
    add_subdirectory(tests)
endif()

=== po/CMakeLists.txt ===
find_program(XGETTEXT_BIN xgettext)
find_program(MSGFMT_BIN msgfmt)
if(NOT MSGFMT_BIN OR NOT XGETTEXT_BIN)
    message(FATAL_ERROR "gettext not found")
endif()
find_package(Python3 COMPONENTS Interpreter)
if(NOT Python3_FOUND)
    message(FATAL_ERROR "python3 not found")
endif()

file(GLOB CPPFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_SOURCE_DIR}/plugins/*/*.cpp")
file(GLOB QMLFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_SOURCE_DIR}/plugins/*/*.qml")
file(GLOB SETTINGSFILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_SOURCE_DIR}/plugins/*/*.settings")
file(RELATIVE_PATH SETTINGSJSFILE "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_CURRENT_SOURCE_DIR}/settings.js")

add_custom_command(OUTPUT ${SETTINGSJSFILE}
    COMMAND ${Python3_EXECUTABLE} ./extractsettingsinfo ${SETTINGSFILES} -o ${SETTINGSJSFILE}
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    DEPENDS ${SETTINGSFILES}
)

add_custom_target(pot-qml
    COMMAND ${XGETTEXT_BIN} -o ${PROJECT_NAME}.pot
                            --join-existing
                            --copyright=\"Canonical Ltd.\"
                            --package-name=${PROJECT_NAME}
                            --qt
                            --c++
                            --add-comments=TRANSLATORS
                            --keyword=QT_TR_NOOP
                            --keyword=ctr:1c,2
                            --keyword=tr
                            --keyword=tr:1,2
                            --from-code=UTF-8
                            --sort-by-file
                            ${QMLFILES}
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    DEPENDS ${QMLFILES}
)

add_custom_target(pot-cpp
    COMMAND ${XGETTEXT_BIN} -o ${PROJECT_NAME}.pot
                            --join-existing
                            --copyright=\"Canonical Ltd.\"
                            --package-name=${PROJECT_NAME}
                            --qt
                            --c++
                            --add-comments=TRANSLATORS
                            --keyword=_
                            --from-code=UTF-8
                            --sort-by-file
                            ${CPPFILES}
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    DEPENDS pot-qml ${CPPFILES}
)

add_custom_target(pot DEPENDS pot-qml pot-cpp)

set(languages "aa;af;am;ar;ast;az;be;bg;br;bs;ca;ckb;cs;cy;da;de;el;en_AU;en_GB;eo;es;eu;fa;fi;fr;fr_CA;ga;gd;gl;gu;he;hi;hr;hu;hy;ia;id;is;it;ja;km;ko;lo;lt;lv;ml;mr;ms;my;nb;nl;oc;pa;pl;pt;pt_BR;ro;ru;sa;sc;shn;si;sk;sl;sq;sr;st;sv;ta;te;th;tr;ug;uk;vi;xh;zh_CN;zh_HK;zh_TW")
foreach(i ${languages})
    add_custom_command(OUTPUT ${i}.mo
        COMMAND ${MSGFMT_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/${i}.po
            -o ${CMAKE_CURRENT_BINARY_DIR}/${i}.mo
        DEPENDS ${i}.po)
    add_custom_target(${i}gen ALL DEPENDS ${i}.mo)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${i}.mo
        DESTINATION share/locale/${i}/LC_MESSAGES
        RENAME lomiri-system-settings-security-privacy.mo)
endforeach()

=== tests/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)

set(XVFB_CMD xvfb-run -a -s "-screen 0 640x480x24")
add_executable(tst-trust-store-model
    tst_trust_store_model.cpp
    ../plugins/security-privacy/trust-store-model.cpp
)
target_include_directories(tst-trust-store-model PRIVATE
    ../plugins/security-privacy
    ${GLIB_INCLUDE_DIRS})
target_compile_definitions(tst-trust-store-model PRIVATE
    TESTS
    DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data")
target_link_libraries(tst-trust-store-model
    ${GLIB_LDFLAGS}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
    Qt5::Test)
add_test(NAME tst-trust-store-model
    COMMAND ${XVFB_CMD} ${CMAKE_CURRENT_BINARY_DIR}/tst-trust-store-model)

=== plugins/security-privacy/CMakeLists.txt ===
set(PLUG_DIR ${PLUGIN_PRIVATE_MODULE_DIR}/Lomiri/SystemSettings/SecurityPrivacy)

set(CMAKE_AUTOMOC ON)

set(HELPER_SOURCES
    polkitlistener.cpp
    helper.cpp
)
add_executable(LomiriSecurityPrivacyHelper ${HELPER_SOURCES})

target_include_directories(LomiriSecurityPrivacyHelper PRIVATE
    ${POLKIT_AGENT_INCLUDE_DIRS}
    ${LIBSYSTEMD_INCLUDE_DIRS})
target_compile_definitions(LomiriSecurityPrivacyHelper PRIVATE
    POLKIT_AGENT_I_KNOW_API_IS_SUBJECT_TO_CHANGE)
target_link_libraries(LomiriSecurityPrivacyHelper
    ${POLKIT_AGENT_LDFLAGS}
    ${LIBSYSTEMD_LDFLAGS})

set(QML_SOURCES
    AppAccess.qml
    AppAccessControl.qml
    here-terms.qml
    Location.qml
    LockSecurity.qml
    Ofono.qml
    PageComponent.qml
    PhoneLocking.qml
    PincodePrompts.qml
    SimPin.qml
    sims.js
    i18nd.js
)
set(PANEL_SOURCES
    connectivity.cpp
    connectivity.h
    plugin.cpp
    plugin.h
    securityprivacy.cpp
    securityprivacy.h
    trust-store-model.cpp
    trust-store-model.h
)
add_library(LomiriSecurityPrivacyPanel MODULE ${PANEL_SOURCES} ${QML_SOURCES})

target_compile_definitions(LomiriSecurityPrivacyPanel PRIVATE
    HELPER_EXEC="${PLUG_DIR}/LomiriSecurityPrivacyHelper"
    QT_NO_KEYWORDS)
target_include_directories(LomiriSecurityPrivacyPanel PRIVATE
    ${Intl_INCLUDE_DIRS}
    ${LomiriSystemSettings_INCLUDE_DIRS}
    ${TRUST_STORE_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
)
target_link_libraries (LomiriSecurityPrivacyPanel
    ${Intl_LIBRARIES}
    Qt5::Core
    Qt5::Gui
    Qt5::Qml
    Qt5::Quick
    Qt5::DBus
    LomiriSystemSettingsPrivate
    ${TRUST_STORE_LDFLAGS}
    ${GLIB_LDFLAGS}
)

install(TARGETS LomiriSecurityPrivacyPanel LomiriSecurityPrivacyHelper
    DESTINATION ${PLUG_DIR})
install(FILES qmldir DESTINATION ${PLUG_DIR})
install(FILES ${QML_SOURCES} DESTINATION ${PLUGIN_QML_DIR}/security-privacy)
install(FILES settings-security-privacy.svg
    DESTINATION ${PLUGIN_MANIFEST_DIR}/icons)
install(FILES security-privacy.settings DESTINATION ${PLUGIN_MANIFEST_DIR})

=== debian/changelog ===
lomiri-system-settings-security-privacy (1.0.2-2) unstable; urgency=medium

  * debian/control:
    + Update LONG_DESCRIPTION fields. Lomiri is not a desktop environment, but
      an operating environment.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 26 Mar 2024 21:39:38 +0100

lomiri-system-settings-security-privacy (1.0.2-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1065803).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 10 Mar 2024 17:43:30 +0100

=== debian/control ===
Source: lomiri-system-settings-security-privacy
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               debhelper-compat (= 13),
               gettext,
               libglib2.0-dev,
               libpolkit-agent-1-dev,
               liblomirisystemsettings-dev,
               liblomirisystemsettingsprivate-dev,
               libqt5sql5-sqlite <!nocheck>,
               libqtdbusmock1-dev <!nocheck>,
               libqtdbustest1-dev <!nocheck>,
               libsystemd-dev,
               lomiri-system-settings <!nocheck>,
               pkgconf,
               python3:any,
               qml-module-lomiri-components <!nocheck>,
               qml-module-lomiri-settings-fingerprint <!nocheck>,
               qml-module-qttest <!nocheck>,
               qml-module-qtquick2 <!nocheck>,
               qtbase5-dev,
               qtbase5-private-dev <!nocheck>,
               qtdeclarative5-dev,
               xvfb <!nocheck>,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/lomiri-system-settings-security-privacy
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-system-settings-security-privacy.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-system-settings-security-privacy/

Package: lomiri-system-settings-security-privacy
Architecture: any
Multi-Arch: same
Depends: lomiri-system-settings,
         qml-module-lomiri-components,
         qml-module-lomiri-settings-fingerprint,
         ${shlibs:Depends},
         ${misc:Depends},
Description: Security and privacy settings plugin for Lomiri system settings
 Lomiri-system-settings is the System Settings application used in Lomiri
 operating environment. it's designed for phones, tablets and convergent
 devices.
 .
 This plugin provides the security and privacy settings plugin to
 lomiri-system-settings.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
export CONFIGURE_FLAGS := -DENABLE_TESTS=OFF
endif

export HOME=$(CURDIR)/debian/test-home

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

override_dh_auto_test:
	mkdir -p $(HOME)
	dh_auto_test

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(HOME)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-system-settings-security-privacy/tags .*/lomiri-system-settings-security-privacy-(\d\S+)\.tar\.gz
